//: C03:Sieve.h
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
#ifndef SIEVE_H
#define SIEVE_H
#include <cmath>
#include <cstddef>
#include <string>
#include "../TestSuite/Test.h"
using std::size_t;
using std::sqrt;
using std::string;

class TestSita : public TestSuite::Test {
  string znakySita;
public:
  // Vytvořit 50 znakový řetězec a nastavit 
	// každý prvek na 'P' jako prvočíslo:
  TestSita() : znakySita(50, 'P') {}
  void run() {
    najdiPrvocisla();
    testPrvocisel();
  }
  bool jePrvocislo(int p) {
    if(p == 0 || p == 1) return false;
    int koren = int(sqrt(double(p)));
    for(int i = 2; i <= koren; ++i)
      if(p % i == 0) return false;
    return true;
  }
  void najdiPrvocisla() {
    // Podle definice není prvočíslo ani 0 ani 1. 
    // Zmenit tyto prvky na 'N' jako není prvočíslo:
    znakySita.replace(0, 2, "NN");
    // Projít pole:
    size_t velikostSita = znakySita.size();
    int koren = int(sqrt(double(velikostSita)));
    for(int i = 2; i <= koren; ++i)
      // Najít všechny násobky:
      for(size_t nasobek = 2; nasobek * i < velikostSita;
           ++nasobek)
        znakySita[nasobek * i] = 'N';
  }
  void testPrvocisel() {
    size_t i = znakySita.find('P');
    while(i != string::npos) {
      test_(jePrvocislo(i++));
      i = znakySita.find('P', i);
    }
    i = znakySita.find_first_not_of('P');
    while(i != string::npos) {
      test_(!jePrvocislo(i++));
      i = znakySita.find_first_not_of('P', i);
    }
  }
};
#endif // SIEVE_H ///:~
